﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Web.Http;
using Jason.Configuration;
using Jason.Factories;
using Jason.Handlers;
using Jason.Runtime;
using Jason.WebAPI.ComponentModel;
using Jason.WebAPI.Runtime;
using Newtonsoft.Json;

namespace Jason.WebAPI
{
	public class JasonWebAPIEndpoint : IJasonServerEndpoint
	{
		public JasonWebAPIEndpoint()
		{
			this.TypeNameHandling = Newtonsoft.Json.TypeNameHandling.Objects;
			this.DefaultSuccessfulHttpResponseCode = HttpStatusCode.OK;
		}

		public TypeNameHandling TypeNameHandling { get; set; }
		public HttpStatusCode DefaultSuccessfulHttpResponseCode { get; set; }

		public void Initialize( IJasonServerConfiguration configuration, IEnumerable<Type> types )
		{
			configuration.Container.RegisterAsTransient( new[] { typeof( JasonController ) }, typeof( JasonController ) );
			configuration.Container.RegisterAsTransient( new[] { typeof( IWebApiCommandDispatcher ) }, typeof( WebApiCommandDispatcher ) );
			configuration.Container.RegisterAsTransient( new[] { typeof( IWebApiJobDispatcher ) }, typeof( WebApiJobDispatcher ) );
			//configuration.Container.RegisterAsTransient( new[] { typeof( ISecurityViolationHandler ) }, typeof( SecurityViolationHandler ) );

			GlobalConfiguration.Configuration
				.Formatters
				.JsonFormatter
				.SerializerSettings
				.TypeNameHandling = this.TypeNameHandling;
		}

		public void Teardown()
		{
			
		}
	}
}
